var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var fix_allow_signup_exports = {};
__export(fix_allow_signup_exports, {
  default: () => FixAllowSignUpMigration
});
module.exports = __toCommonJS(fix_allow_signup_exports);
var import_server = require("@nocobase/server");
var import_preset = require("../../preset");
class FixAllowSignUpMigration extends import_server.Migration {
  appVersion = "<0.18.0-alpha.1";
  async up() {
    var _a;
    const repo = this.context.db.getRepository("authenticators");
    const authenticators = await repo.find({
      filter: {
        authType: import_preset.presetAuthType
      }
    });
    for (const authenticator of authenticators) {
      const options = authenticator.get("options");
      const oldAllowSignUp = (_a = options == null ? void 0 : options.public) == null ? void 0 : _a.allowSignup;
      if (oldAllowSignUp === void 0 || oldAllowSignUp === null) {
        continue;
      }
      options.public.allowSignUp = oldAllowSignUp;
      delete options.public.allowSignup;
      await repo.update({
        values: {
          options
        },
        filter: {
          name: authenticator.name
        }
      });
    }
  }
  async down() {
  }
}
