var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugin_exports = {};
__export(plugin_exports, {
  PluginAuthServer: () => PluginAuthServer,
  default: () => plugin_default
});
module.exports = __toCommonJS(plugin_exports);
var import_server = require("@nocobase/server");
var import_path = require("path");
var import_preset = require("../preset");
var import_auth = __toESM(require("./actions/auth"));
var import_authenticators = __toESM(require("./actions/authenticators"));
var import_basic_auth = require("./basic-auth");
var import_locale = require("./locale");
var import_authenticator = require("./model/authenticator");
var import_storer = require("./storer");
var import_token_blacklist = require("./token-blacklist");
class PluginAuthServer extends import_server.Plugin {
  cache;
  afterAdd() {
  }
  async beforeLoad() {
    this.app.i18n.addResources("zh-CN", import_preset.namespace, import_locale.zhCN);
    this.app.i18n.addResources("en-US", import_preset.namespace, import_locale.enUS);
    this.app.db.registerModels({ AuthModel: import_authenticator.AuthModel });
  }
  async load() {
    await this.importCollections((0, import_path.resolve)(__dirname, "collections"));
    this.db.addMigrations({
      namespace: "auth",
      directory: (0, import_path.resolve)(__dirname, "migrations"),
      context: {
        plugin: this
      }
    });
    this.cache = await this.app.cacheManager.createCache({
      name: "auth",
      prefix: "auth",
      store: "memory"
    });
    const storer = new import_storer.Storer({
      db: this.db,
      cache: this.cache
    });
    this.app.authManager.setStorer(storer);
    if (!this.app.authManager.jwt.blacklist) {
      this.app.authManager.setTokenBlacklistService(new import_token_blacklist.TokenBlacklistService(this));
    }
    this.app.authManager.registerTypes(import_preset.presetAuthType, {
      auth: import_basic_auth.BasicAuth,
      title: "Password"
    });
    Object.entries(import_auth.default).forEach(
      ([action, handler]) => {
        var _a;
        return (_a = this.app.resourcer.getResource("auth")) == null ? void 0 : _a.addAction(action, handler);
      }
    );
    Object.entries(import_authenticators.default).forEach(
      ([action, handler]) => this.app.resourcer.registerAction(`authenticators:${action}`, handler)
    );
    ["check", "signIn", "signUp"].forEach((action) => this.app.acl.allow("auth", action));
    ["signOut", "changePassword"].forEach((action) => this.app.acl.allow("auth", action, "loggedIn"));
    this.app.acl.allow("authenticators", "publicList");
    this.app.acl.registerSnippet({
      name: `pm.${this.name}.authenticators`,
      actions: ["authenticators:*"]
    });
    this.app.db.on("users.afterSave", async (user) => {
      const cache = this.app.cache;
      await cache.set(`auth:${user.id}`, user.toJSON());
    });
    this.app.db.on("users.afterDestroy", async (user) => {
      const cache = this.app.cache;
      await cache.del(`auth:${user.id}`);
    });
  }
  async install(options) {
    const repository = this.db.getRepository("authenticators");
    const exist = await repository.findOne({ filter: { name: import_preset.presetAuthenticator } });
    if (exist) {
      return;
    }
    await repository.create({
      values: {
        name: import_preset.presetAuthenticator,
        authType: import_preset.presetAuthType,
        description: "Sign in with username/email.",
        enabled: true,
        options: {
          public: {
            allowSignUp: true
          }
        }
      }
    });
  }
  async remove() {
  }
}
var plugin_default = PluginAuthServer;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PluginAuthServer
});
